#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <dos.h>
#include "cga.h"

unsigned char* cgadata;
unsigned char* cgaline[200];

void cga_init(void)
{
    union REGS ir, or;
    int i;
    memset(&ir, 0, sizeof(ir));
    memset(&or, 0, sizeof(or));
    ir.x.ax = 4;
    int86(0x10, &ir, &or);
    cgadata = MK_FP(0xB800, 0);
    for (i=0; i < 200; i+=2) cgaline[i] = MK_FP(0xB800, (i>>1)*80);
    for (i=1; i < 200; i+=2) cgaline[i] = MK_FP(0xB800, 0x2000 + ((i-1)>>1)*80);
    memset(MK_FP(0xB800, 0), 0, 16384);
}

void cga_shutdown(void)
{
    union REGS ir, or;
    memset(&ir, 0, sizeof(ir));
    memset(&or, 0, sizeof(or));
    ir.x.ax = 3;
    int86(0x10, &ir, &or);
}

void cga_pset(int x, int y, int c)
{
    cgaline[y][x>>2] &= ~(3<<(3-(x&3)<<1));
    cgaline[y][x>>2] |= c<<(3-(x&3)<<1);
}

void cga_hline(int x1, int x2, int y, int c)
{
    int x;
    for (x=x1; x <= x2; x++) cga_pset(x, y, c);
}

void cga_bar(int x1, int y1, int x2, int y2, int c)
{
    int y;
    for (y=y1; y <= y2; y++) cga_hline(x1, x2, y, c);
}

void cga_tile(int x, int y, const unsigned char* tile)
{
    int yy;
    for (yy=0; yy < 16; yy++) {
        unsigned char* tgt = cgaline[y++] + (x>>2);
        *(tgt++) = *(tile++);
        *(tgt++) = *(tile++);
        *(tgt++) = *(tile++);
        *tgt = *(tile++);
    }
}

void cga_tile_pset(unsigned char* tile, int x, int y, int c)
{
    tile[(y<<2) + (x>>2)] &= ~(3<<(3-(x&3)<<1));
    tile[(y<<2) + (x>>2)] |= c<<(3-(x&3)<<1);
}

unsigned char* cga_load_tiles(const char* filename)
{
    FILE* f = fopen(filename, "rb");
    unsigned char* buff;
    if (!f) return 0;
    buff = malloc(8192);
    if (!buff) {
        fclose(f);
        return 0;
    }
    if (fread(buff, 8192, 1, f) != 1) {
        free(buff);
        fclose(f);
        return 0;
    }
    fclose(f);
    return buff;
}

void cga_msg(int y, const char* msg)
{
    char buff[40], i = 0;
    union REGS ir;
    strncpy(buff, msg, 39);
    memset(buff + strlen(buff), ' ', 40 - strlen(buff));
    buff[39] = 0;
    memset(&ir, 0, sizeof(ir));
    ir.h.ah = 2;
    ir.h.dh = y - 1;
    int86(0x10, &ir, &ir);
    memset(&ir, 0, sizeof(ir));
    while (buff[i]) {
        ir.h.ah = 0xE;
        ir.h.al = buff[i++];
        ir.h.bl = 3;
        int86(0x10, &ir, &ir);
    }
}
